<script setup lang="ts">
import YellowStarEyebrow from '@/assets/icons/yellow-star-eyebrow.vue';
import { ArrowRight } from 'slippers-ui/icons';

type BannerProps = {
  title: string;
  titleMobile: string;
  href: string;
  config: {
    dataGaName: string;
    dataGaLocation: string;
  };
};

defineProps<BannerProps>();
</script>

<template>
  <a :href="href" :data-ga-name="config.dataGaName" :data-ga-location="config.dataGaLocation" class="banner">
    <div class="banner__desktop">
      <img preload class="slp-ml-24 image" src="/images/banner/gitlab-duo-amazon-q.svg" alt="" />
      <div class="content">
        <SlpTypography class="text" variant="body2">{{ title }} </SlpTypography>
        <span class="icon">
          <SlpIcon :icon="ArrowRight" size="sm" class="slp-ml-8" />
        </span>
      </div>
    </div>
    <div class="banner__mobile">
      <div class="pill-content">
        <YellowStarEyebrow class="slp-mr-8" />
        <SlpTypography variant="body3-bold" tag="span">
          {{ titleMobile }}
        </SlpTypography>
        <SlpIcon :icon="ArrowRight" size="sm" class="slp-ml-8" />
      </div>
    </div>
  </a>
</template>

<style lang="scss" scoped>
.banner {
  display: block;

  &:hover {
    :deep(.icon) {
      transform: translateX(8px);
    }
  }

  &__desktop {
    align-items: center;
    background-color: #171321;
    box-sizing: border-box;
    display: flex;
    justify-content: center;
    overflow: hidden;
    width: 100%;

    @media (max-width: $breakpoint-md) {
      display: none;
    }

    .content {
      align-items: center;
      display: flex;
      justify-content: center;
    }

    .icon {
      color: #fff;
      display: flex;
      transition: all 0.3s ease;

      :deep(svg) * {
        fill: currentColor;
      }
    }

    .image {
      margin-right: $spacing-8;
    }

    .text {
      color: $color-text-50;
      padding: $spacing-16 0;
      text-decoration: underline;
    }
  }

  &__mobile {
    --background-gradient: linear-gradient(135deg, #f7a20f, #a989f5, #962eff, #0099ff);
    color: $color-text-300;
    display: block;
    font-size: 14px;
    margin: 9px;
    padding: 8px 12px;
    position: relative;
    text-decoration: none;

    &:before {
      background: var(--background-gradient) border-box;
      border: 2px solid transparent;
      border-radius: 70px;
      content: '';
      inset: 0;
      mask:
        linear-gradient(#fff 0 0) padding-box,
        linear-gradient(#fff 0 0);
      mask-composite: exclude;
      position: absolute;
      -webkit-mask-composite: xor;
    }

    .pill-content {
      align-items: center;
      display: flex;
      justify-content: center;
      position: relative;
      z-index: 1;

      .slp-icon {
        margin-left: $spacing-16;
        transition: transform 0.2s ease-in-out;
      }
    }
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }
}
</style>
